Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -4027,127 +4587,135 @@
     UINT64 old_size = 0;
     BOOL extents_changed;
 #endif
-    
+
     if (fcb->ads) {
-        if (fcb->deleted)
-            delete_xattr(fcb->Vcb, fcb->subvol, fcb->inode, fcb->adsxattr.Buffer, fcb->adshash, Irp, rollback);
-        else {
-            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, fcb->adsxattr.Buffer, fcb->adshash, (UINT8*)fcb->adsdata.Buffer, fcb->adsdata.Length, Irp, rollback);
+        if (fcb->deleted) {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, fcb->adsxattr.Buffer, fcb->adsxattr.Length, fcb->adshash);
             if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
+        } else {
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, fcb->adsxattr.Buffer, fcb->adsxattr.Length,
+                               fcb->adshash, (UINT8*)fcb->adsdata.Buffer, fcb->adsdata.Length);
+            if (!NT_SUCCESS(Status)) {
                 ERR("set_xattr returned %08x\n", Status);
                 goto end;
             }
         }
+
+        Status = STATUS_SUCCESS;
         goto end;
     }
-    
+
     if (fcb->deleted) {
-        if (!insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, 0xffffffffffffffff, NULL, 0, Batch_DeleteInode, Irp, rollback))
-            ERR("insert_tree_item_batch failed\n");
-        
+        Status = insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, 0xffffffffffffffff, NULL, 0, Batch_DeleteInode);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            goto end;
+        }
+
+        Status = STATUS_SUCCESS;
         goto end;
     }
-    
+
 #ifdef DEBUG_PARANOID
     extents_changed = fcb->extents_changed;
 #endif
-    
+
     if (fcb->extents_changed) {
-        BOOL b;
-        traverse_ptr next_tp;
         LIST_ENTRY* le;
         BOOL prealloc = FALSE, extents_inline = FALSE;
         UINT64 last_end;
-        
+
         // delete ignored extent items
         le = fcb->extents.Flink;
         while (le != &fcb->extents) {
             LIST_ENTRY* le2 = le->Flink;
             extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-            
+
             if (ext->ignore) {
                 RemoveEntryList(&ext->list_entry);
-                
+
                 if (ext->csum)
                     ExFreePool(ext->csum);
-                
-                ExFreePool(ext->data);
+
                 ExFreePool(ext);
             }
-            
+
             le = le2;
         }
-        
+
         le = fcb->extents.Flink;
         while (le != &fcb->extents) {
             extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-            
-            if (ext->inserted && ext->csum && ext->data->type == EXTENT_TYPE_REGULAR) {
-                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                
+
+            if (ext->inserted && ext->csum && ext->extent_data.type == EXTENT_TYPE_REGULAR) {
+                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
                 if (ed2->size > 0) { // not sparse
-                    if (ext->data->compression == BTRFS_COMPRESSION_NONE)
-                        add_checksum_entry(fcb->Vcb, ed2->address + ed2->offset, ed2->num_bytes / fcb->Vcb->superblock.sector_size, ext->csum, Irp, rollback);
+                    if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE)
+                        add_checksum_entry(fcb->Vcb, ed2->address + ed2->offset, (ULONG)(ed2->num_bytes / fcb->Vcb->superblock.sector_size), ext->csum, Irp);
                     else
-                        add_checksum_entry(fcb->Vcb, ed2->address, ed2->size / fcb->Vcb->superblock.sector_size, ext->csum, Irp, rollback);
+                        add_checksum_entry(fcb->Vcb, ed2->address, (ULONG)(ed2->size / fcb->Vcb->superblock.sector_size), ext->csum, Irp);
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!IsListEmpty(&fcb->extents)) {
-            rationalize_extents(fcb, Irp, rollback);
-            
+            rationalize_extents(fcb, Irp);
+
             // merge together adjacent EXTENT_DATAs pointing to same extent
-            
+
             le = fcb->extents.Flink;
             while (le != &fcb->extents) {
                 LIST_ENTRY* le2 = le->Flink;
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-                
-                if ((ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) && le->Flink != &fcb->extents) {
+
+                if ((ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) && le->Flink != &fcb->extents) {
                     extent* nextext = CONTAINING_RECORD(le->Flink, extent, list_entry);
-                        
-                    if (ext->data->type == nextext->data->type) {
-                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                        EXTENT_DATA2* ned2 = (EXTENT_DATA2*)nextext->data->data;
-                        
+
+                    if (ext->extent_data.type == nextext->extent_data.type) {
+                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+                        EXTENT_DATA2* ned2 = (EXTENT_DATA2*)nextext->extent_data.data;
+
                         if (ed2->size != 0 && ed2->address == ned2->address && ed2->size == ned2->size &&
                             nextext->offset == ext->offset + ed2->num_bytes && ned2->offset == ed2->offset + ed2->num_bytes) {
                             chunk* c;
-                        
-                            if (ext->data->compression == BTRFS_COMPRESSION_NONE && ext->csum) {
-                                ULONG len = (ed2->num_bytes + ned2->num_bytes) / fcb->Vcb->superblock.sector_size;
+
+                            if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE && ext->csum) {
+                                ULONG len = (ULONG)((ed2->num_bytes + ned2->num_bytes) / fcb->Vcb->superblock.sector_size);
                                 UINT32* csum;
-                                
+
                                 csum = ExAllocatePoolWithTag(NonPagedPool, len * sizeof(UINT32), ALLOC_TAG);
                                 if (!csum) {
                                     ERR("out of memory\n");
+                                    Status = STATUS_INSUFFICIENT_RESOURCES;
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(csum, ext->csum, ed2->num_bytes * sizeof(UINT32) / fcb->Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(csum, ext->csum, (ULONG)(ed2->num_bytes * sizeof(UINT32) / fcb->Vcb->superblock.sector_size));
                                 RtlCopyMemory(&csum[ed2->num_bytes / fcb->Vcb->superblock.sector_size], nextext->csum,
-                                              ned2->num_bytes * sizeof(UINT32) / fcb->Vcb->superblock.sector_size);
-                                
+                                              (ULONG)(ned2->num_bytes * sizeof(UINT32) / fcb->Vcb->superblock.sector_size));
+
                                 ExFreePool(ext->csum);
                                 ext->csum = csum;
                             }
-                            
-                            ext->data->generation = fcb->Vcb->superblock.generation;
+
+                            ext->extent_data.generation = fcb->Vcb->superblock.generation;
                             ed2->num_bytes += ned2->num_bytes;
-                        
+
                             RemoveEntryList(&nextext->list_entry);
-                        
+
                             if (nextext->csum)
                                 ExFreePool(nextext->csum);
-                        
-                            ExFreePool(nextext->data);
+
                             ExFreePool(nextext);
-                        
+
                             c = get_chunk_from_address(fcb->Vcb, ed2->address);
-                                
+
                             if (!c) {
                                 ERR("get_chunk_from_address(%llx) failed\n", ed2->address);
                             } else {
@@ -4158,63 +4726,45 @@
                                     goto end;
                                 }
                             }
-                        
+
                             le2 = le;
                         }
                     }
                 }
-                
+
                 le = le2;
             }
         }
-        
+
         if (!fcb->created) {
             // delete existing EXTENT_DATA items
-            
-            searchkey.obj_id = fcb->inode;
-            searchkey.obj_type = TYPE_EXTENT_DATA;
-            searchkey.offset = 0;
-            
-            Status = find_item(fcb->Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
+
+            Status = insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_EXTENT_DATA, 0, NULL, 0, Batch_DeleteExtentData);
             if (!NT_SUCCESS(Status)) {
-                ERR("error - find_item returned %08x\n", Status);
+                ERR("insert_tree_item_batch returned %08x\n", Status);
                 goto end;
             }
-            
-            do {
-                if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type)
-                    delete_tree_item(fcb->Vcb, &tp, rollback);
-                
-                b = find_next_item(fcb->Vcb, &tp, &next_tp, FALSE, Irp);
-                
-                if (b) {
-                    tp = next_tp;
-                    
-                    if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type > searchkey.obj_type))
-                        break;
-                }
-            } while (b);
         }
-        
+
         // add new EXTENT_DATAs
-        
+
         last_end = 0;
-        
+
         le = fcb->extents.Flink;
         while (le != &fcb->extents) {
             extent* ext = CONTAINING_RECORD(le, extent, list_entry);
             EXTENT_DATA* ed;
-            
+
             ext->inserted = FALSE;
-            
+
             if (!(fcb->Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_NO_HOLES) && ext->offset > last_end) {
-                Status = insert_sparse_extent(fcb, last_end, ext->offset - last_end, Irp, rollback);
+                Status = insert_sparse_extent(fcb, batchlist, last_end, ext->offset - last_end);
                 if (!NT_SUCCESS(Status)) {
                     ERR("insert_sparse_extent returned %08x\n", Status);
                     goto end;
                 }
             }
-                
+
             ed = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
             if (!ed) {
                 ERR("out of memory\n");
@@ -4221,247 +4771,430 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
-            RtlCopyMemory(ed, ext->data, ext->datalen);
-            
-            if (!insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_EXTENT_DATA, ext->offset,
-                                ed, ext->datalen, Batch_Insert, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                Status = STATUS_INTERNAL_ERROR;
+
+            RtlCopyMemory(ed, &ext->extent_data, ext->datalen);
+
+            Status = insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_EXTENT_DATA, ext->offset,
+                                            ed, ext->datalen, Batch_Insert);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item_batch returned %08x\n", Status);
                 goto end;
             }
-            
-            if (ext->datalen >= sizeof(EXTENT_DATA) && ed->type == EXTENT_TYPE_PREALLOC)
+
+            if (ed->type == EXTENT_TYPE_PREALLOC)
                 prealloc = TRUE;
-            
-            if (ext->datalen >= sizeof(EXTENT_DATA) && ed->type == EXTENT_TYPE_INLINE)
+
+            if (ed->type == EXTENT_TYPE_INLINE)
                 extents_inline = TRUE;
-            
+
             if (!(fcb->Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_NO_HOLES)) {
                 if (ed->type == EXTENT_TYPE_INLINE)
                     last_end = ext->offset + ed->decoded_size;
                 else {
                     EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                    
+
                     last_end = ext->offset + ed2->num_bytes;
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!(fcb->Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_NO_HOLES) && !extents_inline &&
             sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size) > last_end) {
-            Status = insert_sparse_extent(fcb, last_end, sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size) - last_end, Irp, rollback);
+            Status = insert_sparse_extent(fcb, batchlist, last_end, sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size) - last_end);
             if (!NT_SUCCESS(Status)) {
                 ERR("insert_sparse_extent returned %08x\n", Status);
                 goto end;
             }
         }
-        
+
         // update prealloc flag in INODE_ITEM
-        
+
         if (!prealloc)
             fcb->inode_item.flags &= ~BTRFS_INODE_PREALLOC;
         else
             fcb->inode_item.flags |= BTRFS_INODE_PREALLOC;
-        
+
         fcb->inode_item_changed = TRUE;
-        
+
         fcb->extents_changed = FALSE;
     }
-    
+
     if ((!fcb->created && fcb->inode_item_changed) || cache) {
         searchkey.obj_id = fcb->inode;
         searchkey.obj_type = TYPE_INODE_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(fcb->Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             goto end;
         }
-        
+
         if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
             if (cache) {
                 ii = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_ITEM), ALLOC_TAG);
                 if (!ii) {
                     ERR("out of memory\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto end;
                 }
-                
+
                 RtlCopyMemory(ii, &fcb->inode_item, sizeof(INODE_ITEM));
-                
-                if (!insert_tree_item(fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
+
+                Status = insert_tree_item(fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
                     goto end;
                 }
-                
+
                 ii_offset = 0;
             } else {
                 ERR("could not find INODE_ITEM for inode %llx in subvol %llx\n", fcb->inode, fcb->subvol->id);
-                int3;
+                Status = STATUS_INTERNAL_ERROR;
                 goto end;
             }
         } else {
 #ifdef DEBUG_PARANOID
             INODE_ITEM* ii2 = (INODE_ITEM*)tp.item->data;
-            
+
             old_size = ii2->st_size;
 #endif
-            
+
             ii_offset = tp.item->key.offset;
         }
-        
-        if (!cache)
-            delete_tree_item(fcb->Vcb, &tp, rollback);
-        else {
+
+        if (!cache) {
+            Status = delete_tree_item(fcb->Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                goto end;
+            }
+        } else {
             searchkey.obj_id = fcb->inode;
             searchkey.obj_type = TYPE_INODE_ITEM;
             searchkey.offset = ii_offset;
-            
+
             Status = find_item(fcb->Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("error - find_item returned %08x\n", Status);
                 goto end;
             }
-            
+
             if (keycmp(tp.item->key, searchkey)) {
                 ERR("could not find INODE_ITEM for inode %llx in subvol %llx\n", fcb->inode, fcb->subvol->id);
-                int3;
+                Status = STATUS_INTERNAL_ERROR;
                 goto end;
             } else
                 RtlCopyMemory(tp.item->data, &fcb->inode_item, min(tp.item->size, sizeof(INODE_ITEM)));
         }
+
+#ifdef DEBUG_PARANOID
+        if (!extents_changed && fcb->type != BTRFS_TYPE_DIRECTORY && old_size != fcb->inode_item.st_size) {
+            ERR("error - size has changed but extents not marked as changed\n");
+            int3;
+        }
+#endif
     } else
         ii_offset = 0;
-    
-#ifdef DEBUG_PARANOID
-    if (!extents_changed && fcb->type != BTRFS_TYPE_DIRECTORY && old_size != fcb->inode_item.st_size) {
-        ERR("error - size has changed but extents not marked as changed\n");
-        int3;
-    }
-#endif
-    
+
     fcb->created = FALSE;
-        
+
     if (!cache && fcb->inode_item_changed) {
         ii = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_ITEM), ALLOC_TAG);
         if (!ii) {
             ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
+
         RtlCopyMemory(ii, &fcb->inode_item, sizeof(INODE_ITEM));
-        
-        if (!insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, ii_offset, ii, sizeof(INODE_ITEM),
-                                    Batch_Insert, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
+
+        Status = insert_tree_item_batch(batchlist, fcb->Vcb, fcb->subvol, fcb->inode, TYPE_INODE_ITEM, ii_offset, ii, sizeof(INODE_ITEM),
+                                        Batch_Insert);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
             goto end;
         }
-        
+
         fcb->inode_item_changed = FALSE;
     }
-    
+
     if (fcb->sd_dirty) {
-        Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_NTACL, EA_NTACL_HASH, (UINT8*)fcb->sd, RtlLengthSecurityDescriptor(fcb->sd), Irp, rollback);
-        if (!NT_SUCCESS(Status)) {
-            ERR("set_xattr returned %08x\n", Status);
+        if (!fcb->sd_deleted) {
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_NTACL, (UINT16)strlen(EA_NTACL),
+                               EA_NTACL_HASH, (UINT8*)fcb->sd, (UINT16)RtlLengthSecurityDescriptor(fcb->sd));
+            if (!NT_SUCCESS(Status)) {
+                ERR("set_xattr returned %08x\n", Status);
+                goto end;
+            }
+        } else {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_NTACL, (UINT16)strlen(EA_NTACL), EA_NTACL_HASH);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
         }
-        
+
+        fcb->sd_deleted = FALSE;
         fcb->sd_dirty = FALSE;
     }
-    
+
     if (fcb->atts_changed) {
         if (!fcb->atts_deleted) {
             UINT8 val[16], *val2;
             ULONG atts = fcb->atts;
-            
+
             TRACE("inserting new DOSATTRIB xattr\n");
-            
+
+            if (fcb->inode == SUBVOL_ROOT_INODE)
+                atts &= ~FILE_ATTRIBUTE_READONLY;
+
             val2 = &val[sizeof(val) - 1];
-            
+
             do {
                 UINT8 c = atts % 16;
-                *val2 = (c >= 0 && c <= 9) ? (c + '0') : (c - 0xa + 'a');
-                
+                *val2 = c <= 9 ? (c + '0') : (c - 0xa + 'a');
+
                 val2--;
                 atts >>= 4;
             } while (atts != 0);
-            
+
             *val2 = 'x';
             val2--;
             *val2 = '0';
-            
-            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_DOSATTRIB, EA_DOSATTRIB_HASH, val2, val + sizeof(val) - val2, Irp, rollback);
+
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_DOSATTRIB, (UINT16)strlen(EA_DOSATTRIB),
+                               EA_DOSATTRIB_HASH, val2, (UINT16)(val + sizeof(val) - val2));
             if (!NT_SUCCESS(Status)) {
                 ERR("set_xattr returned %08x\n", Status);
                 goto end;
             }
-        } else
-            delete_xattr(fcb->Vcb, fcb->subvol, fcb->inode, EA_DOSATTRIB, EA_DOSATTRIB_HASH, Irp, rollback);
-        
+        } else {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_DOSATTRIB, (UINT16)strlen(EA_DOSATTRIB), EA_DOSATTRIB_HASH);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
+        }
+
         fcb->atts_changed = FALSE;
         fcb->atts_deleted = FALSE;
     }
-    
+
     if (fcb->reparse_xattr_changed) {
         if (fcb->reparse_xattr.Buffer && fcb->reparse_xattr.Length > 0) {
-            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_REPARSE, EA_REPARSE_HASH, (UINT8*)fcb->reparse_xattr.Buffer, fcb->reparse_xattr.Length, Irp, rollback);
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_REPARSE, (UINT16)strlen(EA_REPARSE),
+                               EA_REPARSE_HASH, (UINT8*)fcb->reparse_xattr.Buffer, (UINT16)fcb->reparse_xattr.Length);
             if (!NT_SUCCESS(Status)) {
                 ERR("set_xattr returned %08x\n", Status);
                 goto end;
             }
-        } else
-            delete_xattr(fcb->Vcb, fcb->subvol, fcb->inode, EA_REPARSE, EA_REPARSE_HASH, Irp, rollback);
-        
+        } else {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_REPARSE, (UINT16)strlen(EA_REPARSE), EA_REPARSE_HASH);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
+        }
+
         fcb->reparse_xattr_changed = FALSE;
     }
-    
+
     if (fcb->ea_changed) {
         if (fcb->ea_xattr.Buffer && fcb->ea_xattr.Length > 0) {
-            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_EA, EA_EA_HASH, (UINT8*)fcb->ea_xattr.Buffer, fcb->ea_xattr.Length, Irp, rollback);
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_EA, (UINT16)strlen(EA_EA),
+                               EA_EA_HASH, (UINT8*)fcb->ea_xattr.Buffer, (UINT16)fcb->ea_xattr.Length);
             if (!NT_SUCCESS(Status)) {
                 ERR("set_xattr returned %08x\n", Status);
                 goto end;
             }
-        } else
-            delete_xattr(fcb->Vcb, fcb->subvol, fcb->inode, EA_EA, EA_EA_HASH, Irp, rollback);
-        
+        } else {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_EA, (UINT16)strlen(EA_EA), EA_EA_HASH);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
+        }
+
         fcb->ea_changed = FALSE;
     }
-    
+
+    if (fcb->prop_compression_changed) {
+        if (fcb->prop_compression == PropCompression_None) {
+            Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_PROP_COMPRESSION, (UINT16)strlen(EA_PROP_COMPRESSION), EA_PROP_COMPRESSION_HASH);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_xattr returned %08x\n", Status);
+                goto end;
+            }
+        } else if (fcb->prop_compression == PropCompression_Zlib) {
+            const char zlib[] = "zlib";
+
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_PROP_COMPRESSION, (UINT16)strlen(EA_PROP_COMPRESSION),
+                               EA_PROP_COMPRESSION_HASH, (UINT8*)zlib, (UINT16)strlen(zlib));
+            if (!NT_SUCCESS(Status)) {
+                ERR("set_xattr returned %08x\n", Status);
+                goto end;
+            }
+        } else if (fcb->prop_compression == PropCompression_LZO) {
+            const char lzo[] = "lzo";
+
+            Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, EA_PROP_COMPRESSION, (UINT16)strlen(EA_PROP_COMPRESSION),
+                               EA_PROP_COMPRESSION_HASH, (UINT8*)lzo, (UINT16)strlen(lzo));
+            if (!NT_SUCCESS(Status)) {
+                ERR("set_xattr returned %08x\n", Status);
+                goto end;
+            }
+        }
+
+        fcb->prop_compression_changed = FALSE;
+    }
+
+    if (fcb->xattrs_changed) {
+        LIST_ENTRY* le;
+
+        le = fcb->xattrs.Flink;
+        while (le != &fcb->xattrs) {
+            xattr* xa = CONTAINING_RECORD(le, xattr, list_entry);
+            LIST_ENTRY* le2 = le->Flink;
+
+            if (xa->dirty) {
+                UINT32 hash = calc_crc32c(0xfffffffe, (UINT8*)xa->data, xa->namelen);
+
+                if (xa->valuelen == 0) {
+                    Status = delete_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, xa->data, xa->namelen, hash);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_xattr returned %08x\n", Status);
+                        goto end;
+                    }
+
+                    RemoveEntryList(&xa->list_entry);
+                    ExFreePool(xa);
+                } else {
+                    Status = set_xattr(fcb->Vcb, batchlist, fcb->subvol, fcb->inode, xa->data, xa->namelen,
+                                       hash, (UINT8*)&xa->data[xa->namelen], xa->valuelen);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("set_xattr returned %08x\n", Status);
+                        goto end;
+                    }
+
+                    xa->dirty = FALSE;
+                }
+            }
+
+            le = le2;
+        }
+
+        fcb->xattrs_changed = FALSE;
+    }
+
+    Status = STATUS_SUCCESS;
+
 end:
-    fcb->dirty = FALSE;
+    if (fcb->dirty) {
+        BOOL lock = FALSE;
+
+        fcb->dirty = FALSE;
+
+        if (!ExIsResourceAcquiredExclusiveLite(&fcb->Vcb->dirty_fcbs_lock)) {
+            ExAcquireResourceExclusiveLite(&fcb->Vcb->dirty_fcbs_lock, TRUE);
+            lock = TRUE;
+        }
+
+        RemoveEntryList(&fcb->list_entry_dirty);
+
+        if (lock)
+            ExReleaseResourceLite(&fcb->Vcb->dirty_fcbs_lock);
+    }
+
+    return Status;
 }
 
+void add_trim_entry_avoid_sb(device_extension* Vcb, device* dev, UINT64 address, UINT64 size) {
+    int i;
+    ULONG sblen = (ULONG)sector_align(sizeof(superblock), Vcb->superblock.sector_size);
+
+    i = 0;
+    while (superblock_addrs[i] != 0) {
+        if (superblock_addrs[i] + sblen >= address && superblock_addrs[i] < address + size) {
+            if (superblock_addrs[i] > address)
+                add_trim_entry(dev, address, superblock_addrs[i] - address);
+
+            if (size <= superblock_addrs[i] + sblen - address)
+                return;
+
+            size -= superblock_addrs[i] + sblen - address;
+            address = superblock_addrs[i] + sblen;
+        } else if (superblock_addrs[i] > address + size)
+            break;
+
+        i++;
+    }
+
+    add_trim_entry(dev, address, size);
+}
+
 static NTSTATUS drop_chunk(device_extension* Vcb, chunk* c, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
     UINT64 i, factor;
-    CHUNK_ITEM_STRIPE* cis;
-    
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];;
+
     TRACE("dropping chunk %llx\n", c->offset);
-    
+
+    if (c->chunk_item->type & BLOCK_FLAG_RAID0)
+        factor = c->chunk_item->num_stripes;
+    else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
+        factor = c->chunk_item->num_stripes / c->chunk_item->sub_stripes;
+    else if (c->chunk_item->type & BLOCK_FLAG_RAID5)
+        factor = c->chunk_item->num_stripes - 1;
+    else if (c->chunk_item->type & BLOCK_FLAG_RAID6)
+        factor = c->chunk_item->num_stripes - 2;
+    else // SINGLE, DUPLICATE, RAID1
+        factor = 1;
+
+    // do TRIM
+    if (Vcb->trim && !Vcb->options.no_trim) {
+        UINT64 len = c->chunk_item->size / factor;
+
+        for (i = 0; i < c->chunk_item->num_stripes; i++) {
+            if (c->devices[i] && c->devices[i]->devobj && !c->devices[i]->readonly && c->devices[i]->trim)
+                add_trim_entry_avoid_sb(Vcb, c->devices[i], cis[i].offset, len);
+        }
+    }
+
+    if (!c->cache) {
+        Status = load_stored_free_space_cache(Vcb, c, TRUE, Irp);
+
+        if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND)
+            WARN("load_stored_free_space_cache returned %08x\n", Status);
+    }
+
     // remove free space cache
     if (c->cache) {
         c->cache->deleted = TRUE;
-        
+
         Status = excise_extents(Vcb, c->cache, 0, c->cache->inode_item.st_size, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("excise_extents returned %08x\n", Status);
             return Status;
         }
-        
-        flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
-        
-        free_fcb(c->cache);
-        
+
+        Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+
+        free_fcb(Vcb, c->cache);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("flush_fcb returned %08x\n", Status);
+            return Status;
+        }
+
         searchkey.obj_id = FREE_SPACE_CACHE_ID;
         searchkey.obj_type = 0;
         searchkey.offset = c->offset;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
